/*
VideoToolbox.c
Use this file to create a precompiled header in THINK C. While you have this
file open, select Precompile from THINK C's Source menu. Save the result as
"VideoToolbox" in the VideoToolboxSources folder. You may then speed up the
compilation of any project roughly tenfold by typing the line

#include <VideoToolbox>

into the Edit:Options:Prefix window. Note the absence of any ".h" in the
filename.

Unfortunately THINK C isn't very smart about figuring out when a precompiled
header is out of date. If you update any of the THINK C, ANSI C, or
VideoToolbox.h headers, then you should recreate the precompiled header. Also,
the precompiled header will reflect the compiler and language settings in effect
at the time of precompilation, so if you have different projects with different
settings then you may need various versions of the precompiled header. I don't
know which compiler settings matter; the THINK C manual doesn't say. If in
doubt, just skip this whole exercise, and don't use precompiled headers at all.

Header files whose precompilation depends on the mc68881 or mc68020 THINK C
compiler options (e.g. math.h and mc68881.h) were omitted from VideoToolbox.h so
that the resulting precompiled header file can be used in projects regardless of
those options. (You'll want them enabled in your experiments to make full use of
your hardware, but you'll usually want them disabled in demo programs for
maximum compatibility with other peoples computers.) However, changing other
options (e.g. size of double or size of int) will still make it necessary to
rebuild the precompiled header file, to reflect the new settings.

HISTORY:
2/27/93	dgp	Wrote it.
*/
#include "VideoToolbox.h"
